//A bit of a hack to make this automatically enable, in case the user doesn't have it enabled for the dedicated server

function findMapMemoryBox()
{
	%count = AOG_Scroll.getObject(0).getCount();

	for(%a=0;%a<%count;%a++)
	{
		%currObj = AOG_Scroll.getObject(0).getObject(%a);
		if(%currObj.getClassName() $= "GuiCheckboxCtrl")
		{
			if(%currObj.varName $= "Client_mapMemory")
			{
				return(%currObj);
	
				break;
			}
		}
	}
}

function enableMapMemory()
{
	if(!$AddOn__Client_mapMemory)
	{
		clientUpdateAddOnsList();
		%box = findMapMemoryBox();
		if(!isObject(%box))
		{
			error("Error: Client_mapMemory box not found!");
			return;
		}
		%box.setValue(1);
		AOG_tickAddon(%box);
	}
}
if(!$AddOn__Client_mapMemory)
{
	clientUpdateAddOnsList();
	enableMapMemory();
}

package mapMemory
{
	function SM_StartMission()
	{
		%mapName = getField(SM_missionList.getRowTextByID(SM_missionList.getSelectedID()),0);
		%mapPath = getField(SM_missionList.getRowTextByID(SM_missionList.getSelectedID()),2);
		if(%mapName !$= $Pref::LastMap || %mapPath !$= $Pref::LastMapPath)
		{
			$Pref::Server::LastMap = %mapName;
			$Pref::Server::LastMapPath = %mapPath;
			$Pref::LastMap = %mapName;
			$Pref::LastMapPath = %mapPath;
			export("Config/Client/Prefs.cs","$Pref::*");
			export("Config/Server/Prefs.cs","$Pref::Server*");
		}
		parent::SM_StartMission();
	}
	function startMissionGUI::onWake(%this)
	{
		parent::onWake(%this);
		if($Pref::LastMap !$= "")
			SM_missionList.setSelectedByID(findSMMapID($Pref::LastMap));
	}
	function addonsGui::onWake(%this)
	{
		parent::onWake(%this);
		if(!$AddOn__Client_mapMemory)
		{
			enableMapMemory();
		}
		echo("After wake: "@$Addon__Client_mapMemory);
	}
};
activatePackage(mapMemory);

function findSMMapID(%name)
{
	for(%i = 1; %i < SM_MissionList.rowCount(); %i++)
	{
		if(getField(SM_MissionList.getRowTextById(%i), 0) $= %name)
			return %i;
	}
}